/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumberish,
  BytesLike,
  FunctionFragment,
  Result,
  Interface,
  EventFragment,
  AddressLike,
  ContractRunner,
  ContractMethod,
  Listener,
} from "ethers";
import type {
  TypedContractEvent,
  TypedDeferredTopicFilter,
  TypedEventLog,
  TypedLogDescription,
  TypedListener,
  TypedContractMethod,
} from "../common";

export declare namespace SellerUtils {
  export type NodeTierStruct = {
    pricePerNode: BigNumberish;
    supply: BigNumberish;
    capacityPerAddress: BigNumberish;
  };

  export type NodeTierStructOutput = [
    pricePerNode: bigint,
    supply: bigint,
    capacityPerAddress: bigint
  ] & { pricePerNode: bigint; supply: bigint; capacityPerAddress: bigint };
}

export interface SellerUtilsInterface extends Interface {
  getFunction(
    nameOrSignature:
      | "ALLOC_TOO_LOW"
      | "ALREADY_COLLECTED"
      | "CAP_REACHED"
      | "CAP_ZERO"
      | "DUPLICATE"
      | "DURATION_TOO_HIGH"
      | "DURATION_TOO_LOW"
      | "EMPTY_LINK"
      | "GAS_FOR_CALL"
      | "INVALID_SLICE"
      | "LENGTH_TOO_HIGH"
      | "MAX_AMOUNT_EXCEEDED"
      | "MAX_BUY_AMOUNT"
      | "MAX_DURATION"
      | "MAX_PRICE_EXCEEDED"
      | "MAX_TIERS_COUNT"
      | "MIN_DURATION"
      | "NODES_TOTAL_EXCEEDED"
      | "NOTHING_TO_COLLECT"
      | "NOT_ALLOWED"
      | "NOT_COLLECTOR"
      | "NOT_FULFILLED"
      | "NOT_IN_PROGRESS"
      | "NOT_OVER"
      | "OVER"
      | "PRIVATE_DURATION_TOO_HIGH"
      | "SEND_FAILED"
      | "SOFT_CAP_FULFILLED"
      | "SOFT_CAP_NOT_FULFILLED"
      | "STARTED"
      | "START_TOO_LOW"
      | "TIMESTAMPS_CROSS"
      | "WRONG_COST"
      | "WRONG_INDEX"
      | "WRONG_PROOF"
      | "ZERO_ADDRESS"
      | "ZERO_ADMIN"
      | "ZERO_AMOUNT"
      | "ZERO_COLLECTOR"
      | "ZERO_LENGTH"
      | "ZERO_NODES_BOUGHT"
      | "ZERO_PRICE"
      | "ZERO_ROOT"
      | "hasAccess"
      | "strCmp"
      | "validateTiers"
  ): FunctionFragment;

  getEvent(
    nameOrSignatureOrTopic:
      | "ClaimedExtraFunds"
      | "ClaimedFunds"
      | "Init"
      | "PurchasedNodes"
      | "Received"
      | "ResetCollector"
      | "ResetEnd"
      | "ResetLeaves"
      | "ResetNFT"
      | "ResetPrivateSellDuration"
      | "ResetRoot"
      | "ResetStart"
      | "ResetToken"
      | "SetSoftCap"
      | "SetTiers"
      | "UserClaimed"
  ): EventFragment;

  encodeFunctionData(
    functionFragment: "ALLOC_TOO_LOW",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "ALREADY_COLLECTED",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "CAP_REACHED",
    values?: undefined
  ): string;
  encodeFunctionData(functionFragment: "CAP_ZERO", values?: undefined): string;
  encodeFunctionData(functionFragment: "DUPLICATE", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "DURATION_TOO_HIGH",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "DURATION_TOO_LOW",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "EMPTY_LINK",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "GAS_FOR_CALL",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "INVALID_SLICE",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "LENGTH_TOO_HIGH",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "MAX_AMOUNT_EXCEEDED",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "MAX_BUY_AMOUNT",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "MAX_DURATION",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "MAX_PRICE_EXCEEDED",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "MAX_TIERS_COUNT",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "MIN_DURATION",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "NODES_TOTAL_EXCEEDED",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "NOTHING_TO_COLLECT",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "NOT_ALLOWED",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "NOT_COLLECTOR",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "NOT_FULFILLED",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "NOT_IN_PROGRESS",
    values?: undefined
  ): string;
  encodeFunctionData(functionFragment: "NOT_OVER", values?: undefined): string;
  encodeFunctionData(functionFragment: "OVER", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "PRIVATE_DURATION_TOO_HIGH",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "SEND_FAILED",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "SOFT_CAP_FULFILLED",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "SOFT_CAP_NOT_FULFILLED",
    values?: undefined
  ): string;
  encodeFunctionData(functionFragment: "STARTED", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "START_TOO_LOW",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "TIMESTAMPS_CROSS",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "WRONG_COST",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "WRONG_INDEX",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "WRONG_PROOF",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "ZERO_ADDRESS",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "ZERO_ADMIN",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "ZERO_AMOUNT",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "ZERO_COLLECTOR",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "ZERO_LENGTH",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "ZERO_NODES_BOUGHT",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "ZERO_PRICE",
    values?: undefined
  ): string;
  encodeFunctionData(functionFragment: "ZERO_ROOT", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "hasAccess",
    values: [AddressLike, BytesLike[], BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "strCmp",
    values: [string, string]
  ): string;
  encodeFunctionData(
    functionFragment: "validateTiers",
    values: [SellerUtils.NodeTierStruct[]]
  ): string;

  decodeFunctionResult(
    functionFragment: "ALLOC_TOO_LOW",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "ALREADY_COLLECTED",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "CAP_REACHED",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "CAP_ZERO", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "DUPLICATE", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "DURATION_TOO_HIGH",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "DURATION_TOO_LOW",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "EMPTY_LINK", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "GAS_FOR_CALL",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "INVALID_SLICE",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "LENGTH_TOO_HIGH",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "MAX_AMOUNT_EXCEEDED",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "MAX_BUY_AMOUNT",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "MAX_DURATION",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "MAX_PRICE_EXCEEDED",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "MAX_TIERS_COUNT",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "MIN_DURATION",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "NODES_TOTAL_EXCEEDED",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "NOTHING_TO_COLLECT",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "NOT_ALLOWED",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "NOT_COLLECTOR",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "NOT_FULFILLED",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "NOT_IN_PROGRESS",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "NOT_OVER", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "OVER", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "PRIVATE_DURATION_TOO_HIGH",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "SEND_FAILED",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "SOFT_CAP_FULFILLED",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "SOFT_CAP_NOT_FULFILLED",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "STARTED", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "START_TOO_LOW",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "TIMESTAMPS_CROSS",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "WRONG_COST", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "WRONG_INDEX",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "WRONG_PROOF",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "ZERO_ADDRESS",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "ZERO_ADMIN", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "ZERO_AMOUNT",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "ZERO_COLLECTOR",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "ZERO_LENGTH",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "ZERO_NODES_BOUGHT",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "ZERO_PRICE", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "ZERO_ROOT", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "hasAccess", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "strCmp", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "validateTiers",
    data: BytesLike
  ): Result;
}

export namespace ClaimedExtraFundsEvent {
  export type InputTuple = [
    to: AddressLike,
    token: AddressLike,
    amount: BigNumberish
  ];
  export type OutputTuple = [to: string, token: string, amount: bigint];
  export interface OutputObject {
    to: string;
    token: string;
    amount: bigint;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace ClaimedFundsEvent {
  export type InputTuple = [to: AddressLike, amount: BigNumberish];
  export type OutputTuple = [to: string, amount: bigint];
  export interface OutputObject {
    to: string;
    amount: bigint;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace InitEvent {
  export type InputTuple = [
    nft: AddressLike,
    token: AddressLike,
    root: BytesLike
  ];
  export type OutputTuple = [nft: string, token: string, root: string];
  export interface OutputObject {
    nft: string;
    token: string;
    root: string;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace PurchasedNodesEvent {
  export type InputTuple = [
    user: AddressLike,
    nodesAmount: BigNumberish,
    totalCost: BigNumberish
  ];
  export type OutputTuple = [
    user: string,
    nodesAmount: bigint,
    totalCost: bigint
  ];
  export interface OutputObject {
    user: string;
    nodesAmount: bigint;
    totalCost: bigint;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace ReceivedEvent {
  export type InputTuple = [from: AddressLike, amount: BigNumberish];
  export type OutputTuple = [from: string, amount: bigint];
  export interface OutputObject {
    from: string;
    amount: bigint;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace ResetCollectorEvent {
  export type InputTuple = [collector: AddressLike];
  export type OutputTuple = [collector: string];
  export interface OutputObject {
    collector: string;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace ResetEndEvent {
  export type InputTuple = [end: BigNumberish];
  export type OutputTuple = [end: bigint];
  export interface OutputObject {
    end: bigint;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace ResetLeavesEvent {
  export type InputTuple = [link: string];
  export type OutputTuple = [link: string];
  export interface OutputObject {
    link: string;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace ResetNFTEvent {
  export type InputTuple = [nft: AddressLike];
  export type OutputTuple = [nft: string];
  export interface OutputObject {
    nft: string;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace ResetPrivateSellDurationEvent {
  export type InputTuple = [duration: BigNumberish];
  export type OutputTuple = [duration: bigint];
  export interface OutputObject {
    duration: bigint;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace ResetRootEvent {
  export type InputTuple = [root: BytesLike];
  export type OutputTuple = [root: string];
  export interface OutputObject {
    root: string;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace ResetStartEvent {
  export type InputTuple = [start: BigNumberish];
  export type OutputTuple = [start: bigint];
  export interface OutputObject {
    start: bigint;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace ResetTokenEvent {
  export type InputTuple = [token: AddressLike];
  export type OutputTuple = [token: string];
  export interface OutputObject {
    token: string;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace SetSoftCapEvent {
  export type InputTuple = [softCap: BigNumberish];
  export type OutputTuple = [softCap: bigint];
  export interface OutputObject {
    softCap: bigint;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace SetTiersEvent {
  export type InputTuple = [tiers: SellerUtils.NodeTierStruct[]];
  export type OutputTuple = [tiers: SellerUtils.NodeTierStructOutput[]];
  export interface OutputObject {
    tiers: SellerUtils.NodeTierStructOutput[];
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace UserClaimedEvent {
  export type InputTuple = [to: AddressLike, amount: BigNumberish];
  export type OutputTuple = [to: string, amount: bigint];
  export interface OutputObject {
    to: string;
    amount: bigint;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export interface SellerUtils extends BaseContract {
  connect(runner?: ContractRunner | null): SellerUtils;
  waitForDeployment(): Promise<this>;

  interface: SellerUtilsInterface;

  queryFilter<TCEvent extends TypedContractEvent>(
    event: TCEvent,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEventLog<TCEvent>>>;
  queryFilter<TCEvent extends TypedContractEvent>(
    filter: TypedDeferredTopicFilter<TCEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEventLog<TCEvent>>>;

  on<TCEvent extends TypedContractEvent>(
    event: TCEvent,
    listener: TypedListener<TCEvent>
  ): Promise<this>;
  on<TCEvent extends TypedContractEvent>(
    filter: TypedDeferredTopicFilter<TCEvent>,
    listener: TypedListener<TCEvent>
  ): Promise<this>;

  once<TCEvent extends TypedContractEvent>(
    event: TCEvent,
    listener: TypedListener<TCEvent>
  ): Promise<this>;
  once<TCEvent extends TypedContractEvent>(
    filter: TypedDeferredTopicFilter<TCEvent>,
    listener: TypedListener<TCEvent>
  ): Promise<this>;

  listeners<TCEvent extends TypedContractEvent>(
    event: TCEvent
  ): Promise<Array<TypedListener<TCEvent>>>;
  listeners(eventName?: string): Promise<Array<Listener>>;
  removeAllListeners<TCEvent extends TypedContractEvent>(
    event?: TCEvent
  ): Promise<this>;

  ALLOC_TOO_LOW: TypedContractMethod<[], [string], "view">;

  ALREADY_COLLECTED: TypedContractMethod<[], [string], "view">;

  CAP_REACHED: TypedContractMethod<[], [string], "view">;

  CAP_ZERO: TypedContractMethod<[], [string], "view">;

  DUPLICATE: TypedContractMethod<[], [string], "view">;

  DURATION_TOO_HIGH: TypedContractMethod<[], [string], "view">;

  DURATION_TOO_LOW: TypedContractMethod<[], [string], "view">;

  EMPTY_LINK: TypedContractMethod<[], [string], "view">;

  GAS_FOR_CALL: TypedContractMethod<[], [bigint], "view">;

  INVALID_SLICE: TypedContractMethod<[], [string], "view">;

  LENGTH_TOO_HIGH: TypedContractMethod<[], [string], "view">;

  MAX_AMOUNT_EXCEEDED: TypedContractMethod<[], [string], "view">;

  MAX_BUY_AMOUNT: TypedContractMethod<[], [bigint], "view">;

  MAX_DURATION: TypedContractMethod<[], [bigint], "view">;

  MAX_PRICE_EXCEEDED: TypedContractMethod<[], [string], "view">;

  MAX_TIERS_COUNT: TypedContractMethod<[], [bigint], "view">;

  MIN_DURATION: TypedContractMethod<[], [bigint], "view">;

  NODES_TOTAL_EXCEEDED: TypedContractMethod<[], [string], "view">;

  NOTHING_TO_COLLECT: TypedContractMethod<[], [string], "view">;

  NOT_ALLOWED: TypedContractMethod<[], [string], "view">;

  NOT_COLLECTOR: TypedContractMethod<[], [string], "view">;

  NOT_FULFILLED: TypedContractMethod<[], [string], "view">;

  NOT_IN_PROGRESS: TypedContractMethod<[], [string], "view">;

  NOT_OVER: TypedContractMethod<[], [string], "view">;

  OVER: TypedContractMethod<[], [string], "view">;

  PRIVATE_DURATION_TOO_HIGH: TypedContractMethod<[], [string], "view">;

  SEND_FAILED: TypedContractMethod<[], [string], "view">;

  SOFT_CAP_FULFILLED: TypedContractMethod<[], [string], "view">;

  SOFT_CAP_NOT_FULFILLED: TypedContractMethod<[], [string], "view">;

  STARTED: TypedContractMethod<[], [string], "view">;

  START_TOO_LOW: TypedContractMethod<[], [string], "view">;

  TIMESTAMPS_CROSS: TypedContractMethod<[], [string], "view">;

  WRONG_COST: TypedContractMethod<[], [string], "view">;

  WRONG_INDEX: TypedContractMethod<[], [string], "view">;

  WRONG_PROOF: TypedContractMethod<[], [string], "view">;

  ZERO_ADDRESS: TypedContractMethod<[], [string], "view">;

  ZERO_ADMIN: TypedContractMethod<[], [string], "view">;

  ZERO_AMOUNT: TypedContractMethod<[], [string], "view">;

  ZERO_COLLECTOR: TypedContractMethod<[], [string], "view">;

  ZERO_LENGTH: TypedContractMethod<[], [string], "view">;

  ZERO_NODES_BOUGHT: TypedContractMethod<[], [string], "view">;

  ZERO_PRICE: TypedContractMethod<[], [string], "view">;

  ZERO_ROOT: TypedContractMethod<[], [string], "view">;

  hasAccess: TypedContractMethod<
    [user: AddressLike, proof: BytesLike[], root: BytesLike],
    [void],
    "view"
  >;

  strCmp: TypedContractMethod<[a: string, b: string], [boolean], "view">;

  validateTiers: TypedContractMethod<
    [_tiers: SellerUtils.NodeTierStruct[]],
    [void],
    "view"
  >;

  getFunction<T extends ContractMethod = ContractMethod>(
    key: string | FunctionFragment
  ): T;

  getFunction(
    nameOrSignature: "ALLOC_TOO_LOW"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "ALREADY_COLLECTED"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "CAP_REACHED"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "CAP_ZERO"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "DUPLICATE"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "DURATION_TOO_HIGH"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "DURATION_TOO_LOW"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "EMPTY_LINK"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "GAS_FOR_CALL"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "INVALID_SLICE"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "LENGTH_TOO_HIGH"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "MAX_AMOUNT_EXCEEDED"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "MAX_BUY_AMOUNT"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "MAX_DURATION"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "MAX_PRICE_EXCEEDED"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "MAX_TIERS_COUNT"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "MIN_DURATION"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "NODES_TOTAL_EXCEEDED"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "NOTHING_TO_COLLECT"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "NOT_ALLOWED"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "NOT_COLLECTOR"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "NOT_FULFILLED"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "NOT_IN_PROGRESS"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "NOT_OVER"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "OVER"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "PRIVATE_DURATION_TOO_HIGH"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "SEND_FAILED"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "SOFT_CAP_FULFILLED"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "SOFT_CAP_NOT_FULFILLED"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "STARTED"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "START_TOO_LOW"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "TIMESTAMPS_CROSS"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "WRONG_COST"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "WRONG_INDEX"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "WRONG_PROOF"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "ZERO_ADDRESS"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "ZERO_ADMIN"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "ZERO_AMOUNT"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "ZERO_COLLECTOR"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "ZERO_LENGTH"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "ZERO_NODES_BOUGHT"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "ZERO_PRICE"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "ZERO_ROOT"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "hasAccess"
  ): TypedContractMethod<
    [user: AddressLike, proof: BytesLike[], root: BytesLike],
    [void],
    "view"
  >;
  getFunction(
    nameOrSignature: "strCmp"
  ): TypedContractMethod<[a: string, b: string], [boolean], "view">;
  getFunction(
    nameOrSignature: "validateTiers"
  ): TypedContractMethod<
    [_tiers: SellerUtils.NodeTierStruct[]],
    [void],
    "view"
  >;

  getEvent(
    key: "ClaimedExtraFunds"
  ): TypedContractEvent<
    ClaimedExtraFundsEvent.InputTuple,
    ClaimedExtraFundsEvent.OutputTuple,
    ClaimedExtraFundsEvent.OutputObject
  >;
  getEvent(
    key: "ClaimedFunds"
  ): TypedContractEvent<
    ClaimedFundsEvent.InputTuple,
    ClaimedFundsEvent.OutputTuple,
    ClaimedFundsEvent.OutputObject
  >;
  getEvent(
    key: "Init"
  ): TypedContractEvent<
    InitEvent.InputTuple,
    InitEvent.OutputTuple,
    InitEvent.OutputObject
  >;
  getEvent(
    key: "PurchasedNodes"
  ): TypedContractEvent<
    PurchasedNodesEvent.InputTuple,
    PurchasedNodesEvent.OutputTuple,
    PurchasedNodesEvent.OutputObject
  >;
  getEvent(
    key: "Received"
  ): TypedContractEvent<
    ReceivedEvent.InputTuple,
    ReceivedEvent.OutputTuple,
    ReceivedEvent.OutputObject
  >;
  getEvent(
    key: "ResetCollector"
  ): TypedContractEvent<
    ResetCollectorEvent.InputTuple,
    ResetCollectorEvent.OutputTuple,
    ResetCollectorEvent.OutputObject
  >;
  getEvent(
    key: "ResetEnd"
  ): TypedContractEvent<
    ResetEndEvent.InputTuple,
    ResetEndEvent.OutputTuple,
    ResetEndEvent.OutputObject
  >;
  getEvent(
    key: "ResetLeaves"
  ): TypedContractEvent<
    ResetLeavesEvent.InputTuple,
    ResetLeavesEvent.OutputTuple,
    ResetLeavesEvent.OutputObject
  >;
  getEvent(
    key: "ResetNFT"
  ): TypedContractEvent<
    ResetNFTEvent.InputTuple,
    ResetNFTEvent.OutputTuple,
    ResetNFTEvent.OutputObject
  >;
  getEvent(
    key: "ResetPrivateSellDuration"
  ): TypedContractEvent<
    ResetPrivateSellDurationEvent.InputTuple,
    ResetPrivateSellDurationEvent.OutputTuple,
    ResetPrivateSellDurationEvent.OutputObject
  >;
  getEvent(
    key: "ResetRoot"
  ): TypedContractEvent<
    ResetRootEvent.InputTuple,
    ResetRootEvent.OutputTuple,
    ResetRootEvent.OutputObject
  >;
  getEvent(
    key: "ResetStart"
  ): TypedContractEvent<
    ResetStartEvent.InputTuple,
    ResetStartEvent.OutputTuple,
    ResetStartEvent.OutputObject
  >;
  getEvent(
    key: "ResetToken"
  ): TypedContractEvent<
    ResetTokenEvent.InputTuple,
    ResetTokenEvent.OutputTuple,
    ResetTokenEvent.OutputObject
  >;
  getEvent(
    key: "SetSoftCap"
  ): TypedContractEvent<
    SetSoftCapEvent.InputTuple,
    SetSoftCapEvent.OutputTuple,
    SetSoftCapEvent.OutputObject
  >;
  getEvent(
    key: "SetTiers"
  ): TypedContractEvent<
    SetTiersEvent.InputTuple,
    SetTiersEvent.OutputTuple,
    SetTiersEvent.OutputObject
  >;
  getEvent(
    key: "UserClaimed"
  ): TypedContractEvent<
    UserClaimedEvent.InputTuple,
    UserClaimedEvent.OutputTuple,
    UserClaimedEvent.OutputObject
  >;

  filters: {
    "ClaimedExtraFunds(address,address,uint256)": TypedContractEvent<
      ClaimedExtraFundsEvent.InputTuple,
      ClaimedExtraFundsEvent.OutputTuple,
      ClaimedExtraFundsEvent.OutputObject
    >;
    ClaimedExtraFunds: TypedContractEvent<
      ClaimedExtraFundsEvent.InputTuple,
      ClaimedExtraFundsEvent.OutputTuple,
      ClaimedExtraFundsEvent.OutputObject
    >;

    "ClaimedFunds(address,uint256)": TypedContractEvent<
      ClaimedFundsEvent.InputTuple,
      ClaimedFundsEvent.OutputTuple,
      ClaimedFundsEvent.OutputObject
    >;
    ClaimedFunds: TypedContractEvent<
      ClaimedFundsEvent.InputTuple,
      ClaimedFundsEvent.OutputTuple,
      ClaimedFundsEvent.OutputObject
    >;

    "Init(address,address,bytes32)": TypedContractEvent<
      InitEvent.InputTuple,
      InitEvent.OutputTuple,
      InitEvent.OutputObject
    >;
    Init: TypedContractEvent<
      InitEvent.InputTuple,
      InitEvent.OutputTuple,
      InitEvent.OutputObject
    >;

    "PurchasedNodes(address,uint256,uint256)": TypedContractEvent<
      PurchasedNodesEvent.InputTuple,
      PurchasedNodesEvent.OutputTuple,
      PurchasedNodesEvent.OutputObject
    >;
    PurchasedNodes: TypedContractEvent<
      PurchasedNodesEvent.InputTuple,
      PurchasedNodesEvent.OutputTuple,
      PurchasedNodesEvent.OutputObject
    >;

    "Received(address,uint256)": TypedContractEvent<
      ReceivedEvent.InputTuple,
      ReceivedEvent.OutputTuple,
      ReceivedEvent.OutputObject
    >;
    Received: TypedContractEvent<
      ReceivedEvent.InputTuple,
      ReceivedEvent.OutputTuple,
      ReceivedEvent.OutputObject
    >;

    "ResetCollector(address)": TypedContractEvent<
      ResetCollectorEvent.InputTuple,
      ResetCollectorEvent.OutputTuple,
      ResetCollectorEvent.OutputObject
    >;
    ResetCollector: TypedContractEvent<
      ResetCollectorEvent.InputTuple,
      ResetCollectorEvent.OutputTuple,
      ResetCollectorEvent.OutputObject
    >;

    "ResetEnd(uint256)": TypedContractEvent<
      ResetEndEvent.InputTuple,
      ResetEndEvent.OutputTuple,
      ResetEndEvent.OutputObject
    >;
    ResetEnd: TypedContractEvent<
      ResetEndEvent.InputTuple,
      ResetEndEvent.OutputTuple,
      ResetEndEvent.OutputObject
    >;

    "ResetLeaves(string)": TypedContractEvent<
      ResetLeavesEvent.InputTuple,
      ResetLeavesEvent.OutputTuple,
      ResetLeavesEvent.OutputObject
    >;
    ResetLeaves: TypedContractEvent<
      ResetLeavesEvent.InputTuple,
      ResetLeavesEvent.OutputTuple,
      ResetLeavesEvent.OutputObject
    >;

    "ResetNFT(address)": TypedContractEvent<
      ResetNFTEvent.InputTuple,
      ResetNFTEvent.OutputTuple,
      ResetNFTEvent.OutputObject
    >;
    ResetNFT: TypedContractEvent<
      ResetNFTEvent.InputTuple,
      ResetNFTEvent.OutputTuple,
      ResetNFTEvent.OutputObject
    >;

    "ResetPrivateSellDuration(uint256)": TypedContractEvent<
      ResetPrivateSellDurationEvent.InputTuple,
      ResetPrivateSellDurationEvent.OutputTuple,
      ResetPrivateSellDurationEvent.OutputObject
    >;
    ResetPrivateSellDuration: TypedContractEvent<
      ResetPrivateSellDurationEvent.InputTuple,
      ResetPrivateSellDurationEvent.OutputTuple,
      ResetPrivateSellDurationEvent.OutputObject
    >;

    "ResetRoot(bytes32)": TypedContractEvent<
      ResetRootEvent.InputTuple,
      ResetRootEvent.OutputTuple,
      ResetRootEvent.OutputObject
    >;
    ResetRoot: TypedContractEvent<
      ResetRootEvent.InputTuple,
      ResetRootEvent.OutputTuple,
      ResetRootEvent.OutputObject
    >;

    "ResetStart(uint256)": TypedContractEvent<
      ResetStartEvent.InputTuple,
      ResetStartEvent.OutputTuple,
      ResetStartEvent.OutputObject
    >;
    ResetStart: TypedContractEvent<
      ResetStartEvent.InputTuple,
      ResetStartEvent.OutputTuple,
      ResetStartEvent.OutputObject
    >;

    "ResetToken(address)": TypedContractEvent<
      ResetTokenEvent.InputTuple,
      ResetTokenEvent.OutputTuple,
      ResetTokenEvent.OutputObject
    >;
    ResetToken: TypedContractEvent<
      ResetTokenEvent.InputTuple,
      ResetTokenEvent.OutputTuple,
      ResetTokenEvent.OutputObject
    >;

    "SetSoftCap(uint256)": TypedContractEvent<
      SetSoftCapEvent.InputTuple,
      SetSoftCapEvent.OutputTuple,
      SetSoftCapEvent.OutputObject
    >;
    SetSoftCap: TypedContractEvent<
      SetSoftCapEvent.InputTuple,
      SetSoftCapEvent.OutputTuple,
      SetSoftCapEvent.OutputObject
    >;

    "SetTiers(tuple[])": TypedContractEvent<
      SetTiersEvent.InputTuple,
      SetTiersEvent.OutputTuple,
      SetTiersEvent.OutputObject
    >;
    SetTiers: TypedContractEvent<
      SetTiersEvent.InputTuple,
      SetTiersEvent.OutputTuple,
      SetTiersEvent.OutputObject
    >;

    "UserClaimed(address,uint256)": TypedContractEvent<
      UserClaimedEvent.InputTuple,
      UserClaimedEvent.OutputTuple,
      UserClaimedEvent.OutputObject
    >;
    UserClaimed: TypedContractEvent<
      UserClaimedEvent.InputTuple,
      UserClaimedEvent.OutputTuple,
      UserClaimedEvent.OutputObject
    >;
  };
}
